/*
 * Copyright (C) 2012 devesion.com
 * 
 * Contact: Lukas Dembinski <dembol@devesion.com>
 * Initial developer: Lukas Dembinski <dembol@devesion.com>
 * Contributor(s):
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */


package com.devesion.n2io.stage;

/**
 * Synchronous Stage Handler.
 * 
 * @author dembol
 */
public interface SyncStageHandler extends StageHandler {

    /**
     * Handle synchronous stage processing. Returns true when the processing is finished
     * and context should jump to the next stage.
     * 
     * @param ctx StageContext
     * @return true when the processing is finished
     */
    boolean onControl(StageContext ctx) throws StageException;
}
