/*
 * Copyright (C) 2012 devesion.com
 * 
 * Contact: Lukas Dembinski <dembol@devesion.com>
 * Initial developer: Lukas Dembinski <dembol@devesion.com>
 * Contributor(s):
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */


package com.devesion.n2io.samples.http;

import com.devesion.n2io.connection.Connection;
import com.devesion.n2io.connection.ConnectionException;
import com.devesion.n2io.stage.StageContext;
import com.devesion.n2io.stage.StageException;
import com.devesion.n2io.stage.StageHandler;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author dembol
 */
public class StandardHandler implements StageHandler {

    private static final Logger LOGGER = LoggerFactory.getLogger(StandardHandler.class);
        
    protected void closeConnection(StageContext ctx) {
        final Connection c = ctx.getConnection();
        try {
            c.close();
        } catch (ConnectionException ex) {
            LOGGER.error("cannot close connection");
        }
    }
    
    @Override
    public void onClose(StageContext ctx) throws StageException {
        closeConnection(ctx);
    }

    @Override
    public void onEnd(StageContext ctx) throws StageException {
    }

    @Override
    public void onError(StageContext ctx, Throwable t) throws StageException {
        closeConnection(ctx);
    }

    @Override
    public void onStart(StageContext ctx) throws StageException {
    }
}
